<?php
  define('IN_MNews', true);

  @include_once './data/databases/mn-db-config.php';
  include_once './stuff/inc/mn-functions.php';
  $lng = select_lang();
  include_once './stuff/lang/lang_'.$lng.'.php';
  include_once './stuff/inc/mn-definitions.php';

  session_start(); # start session
  
  
  
  if ($_POST["mode"] == "add-comment" && ($conf['comments'])) {
  
    if (empty($_POST["redir"])) $_POST["redir"] = $_SERVER["HTTP_REFERER"];

    if ($_POST["robot"] == $def['comment_antispam_number']) {
      if (!empty($_POST["comment_author"]) && !empty($_POST["comment_text"])) {
        if (strlen($_POST["comment_text"]) >= $def['comment_min_length']) {
          if ((ereg("^[_ a-zA-Z0-9\.\-]+$", $_POST['comment_author'])) && (strlen($_POST["comment_author"]) >= $def['comment_author_min_length'])) {
            if (!empty($_POST["article_id"]) && file_exists("./data/news/".$_POST["article_id"].".txt")) {
              if ($conf['news_encoding'] != 'utf-8') {$comment_text = iconv($conf['news_encoding'], 'utf-8', $_POST["comment_text"]);}
              else $comment_text = $_POST["comment_text"];
              $comment_author = check_text($_POST['comment_author']);
              $comment_email = (isset($_POST["comment_email"]) && check_email($_POST["comment_email"])) ? $_POST["comment_email"] : "";
              $comment_www = check_url($_POST["comment_www"]);
              $comment_text = check_text($comment_text);
              $comment_text = str_replace("\r\n", "[BR]", $comment_text);
              $comment_text = str_replace("\n", "[BR]", $comment_text);
              $comments_content = (file_exists("./data/comments/".$_POST["article_id"].".txt")) ? file_get_contents("./data/comments/".$_POST["article_id"].".txt") : "";
              $comments_content = trim($comments_content);
              $comments_content = str_replace("\r\n\r\n", "\r\n", $comments_content);
              $comments_content .= "\n".time()."|$comment_author|$comment_email|$comment_www||||".$_SERVER['HTTP_USER_AGENT']."|".$_SERVER["REMOTE_ADDR"]."|".gethostbyaddr($_SERVER["REMOTE_ADDR"])."|$comment_text";
              $comments_content = trim($comments_content);
              $cfile = fopen("./data/comments/".$_POST["article_id"].".txt","w");
              @flock($cfile, 2);
              fwrite($cfile, $comments_content);
              fclose($cfile);
              @chmod("./data/comments/".$_POST["article_id"].".txt", 0777);
              
              header("location: ".$_POST["redir"]."#mn-comments");
              exit;
            }
            else {
              $info['red'] = $lang['comm_back_wrong_article_id'];
              $tmpl['add_form'] = false;
              include './stuff/tmpl/comment-form-admin.php';
            }
          }
          else {
            $info['red'] = str_replace("%n%", $def['comment_author_min_length'],  $lang['comm_back_wrong_name']);
            $tmpl['add_form'] = true;
            include './stuff/tmpl/comment-form-admin.php';
          }
        }
        else {
          $info['red'] = str_replace("%n%", $def['comment_min_length'], $lang['comm_back_comm_length']);
          $tmpl['add_form'] = true;
          include './stuff/tmpl/comment-form-admin.php';
        }
      }
      else {
        $info['red'] = $lang['comm_back_empty_values'];
        $tmpl['add_form'] = true;
        include './stuff/tmpl/comment-form-admin.php';
      }
    }
    else {
      $info['red'] = $lang['comm_back_spam'];
      $tmpl['add_form'] = true;
      include './stuff/tmpl/comment-form-admin.php';
    }

  }





  else {

    check_install(); # check install
    user_session();  # check user login time



    if (isset($_GET['comments'])) {
      $comments_content = @file_get_contents("./data/news/".$_GET['comments'].".txt");
      if (($_SESSION["mn_logged"]) && file_exists("./data/news/".$_GET['comments'].".txt") && file_exists("./data/comments/".$_GET['comments'].".txt") && !empty($comments_content)) {
        $news_content = file_get_contents("./data/news/".$_GET['comments'].".txt");
        $news_item = explode("|", $news_content);
        $comments_title = "<div id='comments-top'>".$lang["comm_article_comments"]." <strong>".$news_item[0]."</strong></div>";
        if (!isset($_GET["mode"])) echo $comments_title;
  
        $news_comments = "";
        $comments_file = file("./data/comments/".$_GET['comments'].".txt");
        foreach ($comments_file as $single_comment) {
          $comment = explode("|", $single_comment);
          if ($_GET["mode"] == "list") {
            $news_comments .= "<tr><td class='m'>".$comment[1]."<br /><span style='font-size:0.85em;color:#c0c0c0;' title='".$comment[9]." | ".$comment[7]."'>IP:&nbsp;".$comment[8]."</span></td><td class='c m' style='font-size:0.85em;color:#999;'>".date("j.n.Y", ($comment[0]))."<br />".date("H:i", ($comment[0]))."</td><td><div class='comment-text'>".comment_format($comment[10])."</div></td><td class='c icons-comm'><a href='./mn-comments.php?mode=edit&amp;file=".$_GET['comments']."&amp;id=".$comment[0]."'><img src='./stuff/img/icons/edit.png' alt='E' title='".$lang['comm_edit_comment']."' /></a></td><td class='c icons-comm'><a href='./mn-comments.php?mode=delete&amp;file=".$_GET['comments']."&amp;id=".$comment[0]."'><img src='./stuff/img/icons/cross.png' alt='X' title='".$lang['comm_delete_comment']."' /></a></td></tr>";
            $tmpl['comments_list'] = true;
            $echo['page_title'] = $lang["comm_article_comments"]." ".$news_item[0];
            $info['main'] = $lang["comm_article_comments"]." <strong>".$news_item[0]."</strong>";
          }
          else echo "<div class='mn-comment'><div class='mn-comment-top'><span style='float:right'><a href='./mn-comments.php?mode=edit&amp;file=".$_GET['comments']."&amp;id=".$comment[0]."'><img src='./stuff/img/icons/edit.png' alt='E' title='".$lang['comm_edit_comment']."' /></a> <a href='./mn-comments.php?mode=delete&amp;file=".$_GET['comments']."&amp;id=".$comment[0]."'><img src='./stuff/img/icons/cross.png' alt='X' title='".$lang['comm_delete_comment']."' /></a></span> <strong>".$comment[1]."</strong> <em>".date("j.n.Y H:i", ($comment[0]))."</em></div>".comment_format($comment[10])."</div>";
        }
      }
      else echo "<div id='comments-top'><img src='./stuff/img/icons/information.png' alt='(i)' /> ".$lang['comm_no_comments']."</div>";
    }





    elseif (isset($_GET["file"]) && isset($_GET["id"]) && file_exists("./data/news/".$_GET["file"].".txt") && file_exists("./data/comments/".$_GET["file"].".txt")) {
      $comments_file = file("./data/comments/".$_GET["file"].".txt");
  
      foreach ($comments_file as $single_comment) {
        $comment = explode("|", $single_comment);
        if ($comment[0] == $_GET["id"]) {
          $echo["comment_id"] = $comment[0];
          $echo["comment_file"] = $_GET["file"];
          $echo["author"] = $comment[1];
          $echo["email"] = $comment[2];
          $echo["www"] = $comment[3];
          $echo["ip_address"] = $comment[8];
          $echo["host"] = $comment[9];
          $echo["browser"] = $comment[7];
          $echo["text"] = $comment[10];
        }
        else continue;
      }
      if (empty($echo["comment_id"])) {
        $info['red'] = $echo['page_title'] = $lang['comm_no_comment'];
        $tmpl = true;
      }
      elseif ($_GET["mode"] == "delete") {
        $info['main'] = $echo['page_title'] = $lang['comm_delete'];
        $tmpl['form_delete_comment'] = true;
      }
      else {
        $info['main'] = $echo['page_title'] = $lang['comm_edit'];
        $tmpl['form_edit_comment'] = true;
      }
    }



    elseif ($_POST["mode"] == "edit-comment") {

      $echo["comment_id"] = $_POST["comment_id"];
      $echo["comment_file"] = $_POST["comment_file"];
      $echo["author"] = $_POST["comment_author"];
      $echo["email"] = $_POST["comment_email"];
      $echo["www"] = $_POST["comment_www"];
      $echo["ip_address"] = $_POST["comment_ip_address"];
      $echo["host"] = $_POST["comment_host"];
      $echo["browser"] = $_POST["comment_browser"];
      $echo["text"] = $_POST["comment_text"];

      if (!empty($_POST["comment_author"]) && !empty($_POST["comment_text"])) {
        if (strlen($_POST["comment_text"]) >= $def['comment_min_length']) {
          if ((ereg("^[_ a-zA-Z0-9\.\-]+$", $_POST['comment_author'])) && (strlen($_POST["comment_author"]) >= $def['comment_author_min_length'])) {
            if (!empty($_POST["comment_file"]) && file_exists("./data/news/".$_POST["comment_file"].".txt")) {
              $comment_author = check_text($_POST['comment_author']);
              $comment_email = (isset($_POST["comment_email"]) && check_email($_POST["comment_email"])) ? $_POST["comment_email"] : "";
              $comment_www = check_url($_POST["comment_www"]);
              $comment_text = trim($_POST["comment_text"]);
              $comment_text = strip_slashes($comment_text);
              $comment_text = str_replace("|", "&brvbar", $comment_text);
              $comment_text = str_replace("\r\n", " [BR] ", $comment_text);
              $comment_text = str_replace("\n", " [BR] ", $comment_text);
              $comment_file = file("./data/comments/".$_POST["comment_file"].".txt");
              $comments_content = "";
              foreach ($comment_file as $single_comment) {
                $comment = explode("|", $single_comment);
                if ($comment[0] == $_POST["comment_id"]) $comments_content .= $_POST["comment_id"]."|$comment_author|$comment_email|$comment_www||||".$_POST["comment_browser"]."|".$_POST["comment_ip_address"]."|".$_POST["comment_host"]."|".$comment_text."\n";
                else $comments_content .= $single_comment;
              }
              $comments_content = str_replace("\r\n", " ", $comments_content);
              $cfile = fopen("./data/comments/".$_POST["comment_file"].".txt","w");
              fwrite($cfile, $comments_content);
              fclose($cfile);
              @chmod("./data/comments/".$_POST["comment_file"].".txt", 0777);

              header("location: ./mn-comments.php?mode=edit&file=".$_POST["comment_file"]."&id=".$_POST["comment_id"]."&back=edited");
              exit;
            }
            else {
              $info['red'] = $lang['comm_back_wrong_article_id'];
              $tmpl['form_edit_comment'] = true;
            }
          }
          else {
            $info['red'] = str_replace("%n%", $def['comment_author_min_length'],  $lang['comm_back_wrong_name']);
            $tmpl['form_edit_comment'] = true;
          }
        }
        else {
          $info['red'] = str_replace("%n%", $def['comment_min_length'], $lang['comm_back_comm_length']);
          $tmpl['form_edit_comment'] = true;
        }
      }
      else {
        $info['red'] = $lang['comm_back_empty_values'];
        $tmpl['form_edit_comment'] = true;
      }
    }





    elseif ($_POST["mode"] == "delete") {
      if (file_exists("./data/comments/".$_POST["comment_file"].".txt") && !isset($_POST["cancel"])) {
        $comment_file = file("./data/comments/".$_POST["comment_file"].".txt");
        $comments_content = "";
        foreach ($comment_file as $single_comment) {
          $comment = explode("|", $single_comment);
          if ($comment[0] != $_POST["comment_id"]) $comments_content .= $single_comment;
          else continue;
        }
        $comments_content = str_replace("\r\n", " ", $comments_content);
        $comments_content = trim($comments_content);
        if (empty($comments_content)) {unlink("./data/comments/".$_POST["comment_file"].".txt");}
        else {
          $cfile = fopen("./data/comments/".$_POST["comment_file"].".txt","w");
          fwrite($cfile, $comments_content);
          fclose($cfile);
          @chmod("./data/comments/".$_POST["comment_file"].".txt", 0777);
        }

        header("location: ./mn-comments.php?back=deleted");
        exit;
      }
      else {
        header("location: ./mn-comments.php?back=cancel");
        exit;
      }      
    }





    elseif ($_GET["mode"] == "news-list") {
      $directory = dir("./data/comments/");
      while($mnfile = $directory->read()) {
        if (!is_file("./data/news/".$mnfile)) continue;
        $comments_files[] = $mnfile;
      }
  
      if (!empty($comments_files)) {
        $max = count($comments_files);
        sort($comments_files);
        $comments_files = array_reverse($comments_files);
        $news_list = "";
        for ($i = 0; $i <= $max-1; $i++) {
          $news_obsah = file_get_contents("./data/news/".$comments_files[$i]."", "r");
          $news_text = explode("|", $news_obsah);
          $news_id= explode(".", $comments_files[$i]);
          $news_list .= "\t\t\t\t<option value='".$news_id[0]."'>".date("d.m.Y", ($news_id[0]))." - ".$news_text[0]."</option>\n";
        }
        $tmpl["form_news_list"] = true;
        $info['main'] = $echo['page_title'] = $lang['comm_news_comments'];
      }
      else {
        $echo['page_title'] = $lang['comm_comments'];
        $info['neutral'] = $lang['comm_no_comments_at_all'];
        $tmpl = true;
      }
    }





    else {
      $directory = dir("./data/comments/");
      $comments_content = "";
      while($mnfile = $directory->read()) {
        if (!is_file("./data/comments/".$mnfile)) continue;
        $comments_file = file("./data/comments/".$mnfile);
        foreach ($comments_file as $single_line) {
          if (empty($single_line)) continue;
          $last_comments[] = $single_line."|".str_replace(".txt", "", $mnfile)."\n";
        }
      }
      if (!empty($last_comments)) {
        sort($last_comments);
        $last_comments = array_reverse($last_comments);
        $last_comments_content = "";
        $max = (count($last_comments) < 9) ? count($last_comments) : 9;
        for ($i=0; $i<=$max; $i++) {
          if (empty($last_comments[$i])) continue;
          else {
            $last_comment = explode("|", $last_comments[$i]);
            $last_comments_content .= "<tr><td class='m'>".$last_comment[1]."<br /><span style='font-size:0.85em;color:#999;' title='".$last_comment[9]." | ".$last_comment[7]."'>IP:&nbsp;".$last_comment[8]."</span></td><td class='c m' style='font-size:0.85em;color:#999;'>".date("j.n.Y", ($last_comment[0]))."<br />".date("H:i", ($last_comment[0]))."</td><td><div class='comment-text'>".comment_format($last_comment[10])."</div></td><td class='c icons-comm'><a href='./mn-comments.php?mode=edit&amp;file=".$last_comment[11]."&amp;id=".$last_comment[0]."'><img src='./stuff/img/icons/edit.png' alt='E' title='".$lang['comm_edit_comment']."' /></a></td><td class='c icons-comm'><a href='./mn-comments.php?mode=delete&amp;file=".$last_comment[11]."&amp;id=".$last_comment[0]."'><img src='./stuff/img/icons/cross.png' alt='X' title='".$lang['comm_delete_comment']."' /></a></td></tr>";
          }
        }
        $last_comments_content = trim($last_comments_content);
        $tmpl['comments_list'] = true;
        $info['main'] = $echo['page_title'] = $lang['comm_last_comments'];
      }
      else {
        $echo['page_title'] = $lang['comm_comments'];
        $info['neutral'] = $lang['comm_no_comments_at_all'];
        $tmpl = true;
      }
    }





    if ($_GET["back"] == "cancel") {
      $tmpl = true;
      $info['neutral'] = $echo['page_title'] = $lang['comm_back_canceled'];
    }
    elseif ($_GET["back"] == "edited") {
      $echo['page_title'] = $lang['comm_edit'];
      $info['green'] = $lang['comm_back_edited'];
    }
    elseif ($_GET["back"] == "deleted") {
      $tmpl = true;
      $info['neutral'] = $echo['page_title'] = $lang['comm_back_deleted'];
    }


  }




  if (isset($tmpl) && $tmpl['add_form'] != true) {
    include './stuff/tmpl/page-top.php';
    include './stuff/tmpl/feedback-info.php';
    if (($echo['page_title'] == $lang['comm_last_comments']) || ($_GET["mode"] == "news-list") || ($_GET["mode"] == "list")) {
?>

  <p class="r"><span id='sim-select' onclick="ShowHide('tmpl-select');"><img width="14" height="14" src='./stuff/img/icons/comment_edit.png' alt='comments edit' /> <?php echo $lang['comm_choose_comments_list'];?></span><?php echo $lang['gen_jump_to'];?>:</p>
  <div id="tmpl-select">
    <a href="./mn-comments.php"><?php echo $lang['comm_last_comments'];?></a>
    <a href="./mn-comments.php?mode=news-list"><?php echo $lang['comm_news_comments'];?></a>
  </div>

<?php
    }
  }
  
  
/* ---------- Zobrazenie zoznamu noviniek na upravu --------------------------------------------- */
  if ($tmpl["form_news_list"]) { 
?>

  <form action='./mn-comments.php' method='get'>
    <fieldset>
      <input type='hidden' name='mode' value='list' />
      <select name='comments' class='xlong' size='15'>
        <?php echo $news_list;?>
      </select>
      <p>
        <button type='submit'><img src='./stuff/img/icons/magnifier.png' alt='&bull;' /> <?php echo $lang['comm_select_article'];?></button>
      </p>
    </fieldset>
  </form>

<?php
  }
  if ($tmpl["form_edit_comment"]) {
?>

  <form action="./mn-comments.php" method="post">
    <fieldset>
      <table>
        <tr><td style="width: 100px;"><label for="comment_author"><img src='./stuff/img/icons/user.png' alt='user' /> <?php echo $lang['comm_author'];?>:</label></td><td><input type="text" name="comment_author" class="long" id="comment_author" value="<?php echo check_text($echo['author']);?>" /></td></tr>
        <tr><td><label for="comment_email"><img src='./stuff/img/icons/email.png' alt='e-mail' /> <?php echo $lang['comm_email'];?>:</label></td><td><input type="text" name="comment_email" class="long" id="comment_email" value="<?php echo check_text($echo['email']);?>" /></td></tr>
        <tr><td><label for="comment_www"><img src='./stuff/img/icons/world.png' alt='www' /> <?php echo $lang['comm_www'];?>:</label></td><td><input type="text" name="comment_www" class="long" id="comment_www" value="<?php echo check_text($echo['www']);?>" /></td></tr>
        <tr><td colspan="2"><img src='./stuff/img/icons/comment.png' alt='comment' /> <?php echo $lang['comm_text'];?>:</td></tr>
      </table>
      <?php $mn_main_dir = '.'; include './stuff/tmpl/comment-format-buttons.php';?>
      <textarea name="comment_text" id="comment_text" rows="5" cols="40"><?php echo check_text($echo['text']);?></textarea>
      <p class='r' style="margin: 0; padding: 3px 160px 0 0;"><span class='simurl' onclick="ShowHide('comment-info');"><img src='./stuff/img/icons/information.png' alt='(i)' /></span></p>
      <div id='comment-info'>
        <?php
          echo $lang['comm_date'].": <span>".date("j.n.Y H:i", ($echo['comment_id']))."</span><br />";
          echo $lang['comm_ip_address'].": <span>".$echo['ip_address']."</span><br />";
          echo $lang['comm_host'].": <span>".$echo['host']."</span><br />";
          echo $lang['comm_browser'].": <span>".$echo['browser']."</span>";
        ?>
      </div>
      <p>
        <input type="hidden" name="mode" value="edit-comment" />
        <input type="hidden" name="comment_file" value="<?php echo $echo['comment_file'];?>" />
        <input type="hidden" name="comment_id" value="<?php echo $echo['comment_id'];?>" />
        <input type="hidden" name="comment_ip_address" value="<?php echo $echo['ip_address'];?>" />
        <input type="hidden" name="comment_host" value="<?php echo $echo['host'];?>" />
        <input type="hidden" name="comment_browser" value="<?php echo $echo['browser'];?>" />
        <button type='submit' name='submit'><img src='./stuff/img/icons/comment_edit.png' alt='edit' /> <?php echo $lang['comm_edit_comment'];?></button>
      </p>
    </fieldset>
  </form>

<?php
  }
  if ($tmpl["form_delete_comment"]) { 
?>

  <form action='./mn-comments.php' method='post'>
    <fieldset>
      <?php echo $lang['comm_really_delete'];?>?
      <div class='preview'><?php echo comment_format($echo["text"]);?></div>
      <p>
        <span class='red-text'><?php echo $lang['gen_no_go_back'];?></span>
        <input type='hidden' name='mode' value='delete' />
        <input type='hidden' name='comment_file' value='<?php echo $echo["comment_file"];?>' />
        <input type='hidden' name='comment_id' value='<?php echo $echo["comment_id"];?>' /><br />
        <button type='submit' name='cancel'><img src='./stuff/img/icons/cross.png' alt='Cancel' /> <?php echo $lang['comm_cancel'];?></button>
        <button type='submit' name='submit'><img src='./stuff/img/icons/delete.png' alt='Delete' /> <?php echo $lang['comm_delete_comment'];?></button>
      </p>
    </fieldset>
  </form>

<?php
  }
  if ($tmpl['comments_list']) {
    echo "<table id='admin-list'>";
    echo "<tr><th>".$lang['comm_author']."</th><th>".$lang['comm_date']."</th><th>".$lang['comm_text']."</th><th>".$lang['gen_edit']."</th><th>".$lang['gen_delete']."</th></tr>";
    echo $news_comments.$last_comments_content;
    echo "</table>";
    echo "<p class='cleaner'>&nbsp;</p>";
  }
  
  if (isset($tmpl) && $tmpl['add_form'] != true) {
    include './stuff/tmpl/page-bottom.php';
  }
?>
